import logging


log = logging.getLogger('pythonConfig')

try:
    from colorlog import ColoredFormatter

    LOG_LEVEL = logging.DEBUG
    LOGFORMAT = ('%(log_color)s%(message)s%(reset)s')
    logging.root.setLevel(LOG_LEVEL)
    formatter = ColoredFormatter(LOGFORMAT)
    stream = logging.StreamHandler()
    stream.setLevel(LOG_LEVEL)
    stream.setFormatter(formatter)
    log.setLevel(LOG_LEVEL)
    log.addHandler(stream)

    # barvičky ;-)
    # log.debug("A quirky message only developers care about")
    # log.info("Curious users might want to know this")
    # log.warn("Something is wrong and any user should be informed")
    # log.error("Serious stuff, this is red for a reason")
    # log.critical("OH NO everything is on fire")

except ImportError:
    ColoredFormatter = None
    logging.basicConfig(level=logging.DEBUG, format='%(levelname)-8s '
                        '%(message)s')
